/*
 * Copyright (C) 2016 AriaLyy(https://github.com/AriaLyy/Aria)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.arialyy.aria.core.download;

import android.text.TextUtils;
import com.arialyy.aria.core.inf.AbsTaskEntity;
import com.arialyy.aria.orm.DbEntity;

/**
 * Created by Aria.Lao on 2017/7/26.
 * ftp文件夹下载
 */
public class FtpDirDownloadTarget
    extends BaseGroupTarget<FtpDownloadTarget, DownloadGroupTaskEntity> {
  private String serverIp, remotePath, mGroupName;
  private int port;

  FtpDirDownloadTarget(String url, String targetName) {
    init(url);
    String[] pp = url.split("/")[2].split(":");
    this.serverIp = pp[0];
    this.port = Integer.parseInt(pp[1]);
    mTaskEntity.requestType = AbsTaskEntity.FTP;
    remotePath = url.substring(url.indexOf(pp[1]) + pp[1].length(), url.length());
    if (TextUtils.isEmpty(remotePath)) {
      throw new NullPointerException("ftp服务器地址不能为null");
    }
    mTargetName = targetName;
    int lastIndex = url.lastIndexOf("/");
    mTaskEntity.remotePath = remotePath;
    mEntity.setDirPath(url.substring(lastIndex + 1, url.length()));
  }

  private void init(String key) {
    mGroupName = key;
    mTaskEntity = DbEntity.findFirst(DownloadGroupTaskEntity.class, "key=?", key);
    if (mTaskEntity == null) {
      mTaskEntity = new DownloadGroupTaskEntity();
      mTaskEntity.key = key;
      mTaskEntity.entity = getDownloadGroupEntity();
      mTaskEntity.insert();
    }
    if (mTaskEntity.entity == null) {
      mTaskEntity.entity = getDownloadGroupEntity();
    }
    mEntity = mTaskEntity.entity;
  }
}
